package alejandro;

import deb.BaseFeedDynamic;
import deb.Parameters;
import deb.Population;
import deb.Simulator;
import deb.control.Controller;
import deb.fishtank.RotiferPopulation;

public class er_sfrController implements Controller {

	private double ref, sfr, err;
	private double Kp, Ki, Kd;
	private double int_e, ek1, sat_e, sat_d;
	private int count;
	private double dz;
	private double total;
	private double ts;
	private double rot_den;
//	private double max, min, tmax, tmin, max_cand, min_cand, tmaxc, tminc;
//	private int nmaxc, nminc;
	private boolean first, second, third;
	
	public er_sfrController(){
//		ref = Egg Ratio reference
		ref = 0.35;
		err=0;

		Kp = 0.006;
		Ki = 0.03;
		Kd = 0.21;
		int_e = 0;
		ek1 = 0;
		sat_e = ref / 6;
		sat_d = 0.12;
		count = 1;
		dz = 0.000001;
		total = 0;
		sfr = 1.8e-006;
		ts = 0.02083; //Ts = 0.5 hour aprox.
		rot_den = 50;
//		max = 0;
//		min = 1000000;
//		max_cand = 0;
//		min_cand = 1000000;
//		tmax = 0;
//		tmin = 0;
//		tmaxc = 0;
//		tminc = 0;
//		nmaxc = 0;
//		nminc = 0;
		first = true;
		second = true;
		third = true;
	}
	
	public void setParams(double p, double i, double d){
		this.Kp = p;
		this.Ki = i;
		this.Kd = d;
	}
	
	public void setRef(double r){
		this.ref = r;
		sat_e = this.ref / 6;
	}
	
	public double getCallInterval() {
		// TODO Auto-generated method stub
		return ts;
	}

	public void makeControlRun(double t, Simulator sim, Population pop, Parameters envPar) {
		// TODO Auto-generated method stub
		BaseFeedDynamic bfd = pop.getBaseFeedDynamic();
		double feed, dif_e, u;

		RotiferPopulation rotPop = (RotiferPopulation)pop;
		
		if(count == 1){
			
			rot_den = pop.getHerbivoreCount() / envPar.get("V_w0", 0) / 1000;
			System.out.println("Rotifer density: "+rot_den+" rot/ml");
			
			double er = rotPop.getEggRate();
			System.out.println("Egg rate: "+er+" egg/rot");
			err = ref - er;

			try{
				sfr = (0.184/(0.537 - 0.9*er))/1000000;
			}catch(Exception e){}
			if(sfr < 0) sfr = 0.74e-006;
			else if(sfr > 1.6e-006) sfr = 1.6e-006;
			
			count++;
		}
		else{
			if(count < 49) count++;
			else{
				count = 1;
				if(first) first = false;
				else if(second) second = false;
				else if(third) third = false;
			}
		}

		if(first || second || third){
			sfr = 1.0e-006;
			feed = sfr*(rot_den*envPar.get("V_w0", 0)*1000)*(0.01*ts);
			u = feed;
		}
		else{
			feed = sfr*(rot_den*envPar.get("V_w0", 0)*1000)*(0.009*ts);

			dif_e = err - ek1;
			if (dif_e < -sat_d) dif_e = -sat_d;
			else if (dif_e > sat_d) dif_e = sat_d;
			ek1 = err;
			int_e = int_e + err;
			if (int_e < -sat_e) int_e = -sat_e;
			else if (int_e > sat_e) int_e = sat_e;
			System.out.println("Accumulated error: "+int_e);
			
			u = feed + (err*Kp) + (int_e*Ki) + (dif_e*Kd);
		}
			
		if (u >= dz){
			bfd.increaseLevel(u);
			total = total + u;
/*

			if(u > max && u != max_cand){
				max_cand = u;
				tmaxc = t;
				nmaxc = 1;
			}
			else if(u == max_cand){
				nmaxc++;
				if(nmaxc >= 30){
					max = max_cand;
					tmax = tmaxc;
				}
			}
			if(u < min && u != min_cand){
				min_cand = u;
				tminc = t;
				nminc = 1;
			}
			else if(u == min_cand){
				nminc++;
				if(nminc >= 30){
					min = min_cand;
					tmin = tminc;
				}
			}
*/			
			System.out.println(u+" g/l added");
			System.out.println("Total feed added: "+total+" g/l");
//			System.out.println("Max: "+max+" g/l - t = "+tmax);
//			System.out.println("min: "+min+" g/l - t = "+tmin);
		}
		else if (u < 0){
			bfd.increaseLevel(feed);
			total = total + feed;
/*				
				if(feed > max && feed != max_cand){
					max_cand = feed;
					tmaxc = t;
					nmaxc = 1;
				}
				else if(feed == max_cand){
					nmaxc++;
					if(nmaxc >= 30){
						max = max_cand;
						tmax = tmaxc;
					}
				}
				if(feed < min && feed != min_cand){
					min_cand = feed;
					tminc = t;
					nminc = 1;
				}
				else if(feed == min_cand){
					nminc++;
					if(nminc >= 30){
						min = min_cand;
						tmin = tminc;
					}
				}
*/
			System.out.println(feed+" g/l added");
			System.out.println("Total feed added: "+total+" g/l");
//				System.out.println("Max: "+max+" g/l - t = "+tmax);
//				System.out.println("min: "+min+" g/l - t = "+tmin);
		}
	}
}
