/*
 * Created on 29.okt.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package deb;

/**
 * @author alver
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class CombinedPair implements Comparable {

	Individual one, two;
	double distance;
	
	public CombinedPair(Individual one, Individual two) {
		this(one, two, one.compareTo(two));
	}
	
	public CombinedPair(Individual one, Individual two, double distance) {
		this.distance = distance;
		this.one = one;
		this.two = two;
                if (one.getClass() != two.getClass())
                    throw new RuntimeException(one.getClass()+" / "+two.getClass());
	}
	
	public Individual getOne() {
		return one;
	}
	
	public Individual getTwo() {
		return two;
	}

	public double getDistance() {
		return distance;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	public int compareTo(Object arg0) {
		CombinedPair other = (CombinedPair)arg0;
		return ((distance - other.getDistance()) > 0) ? 1 : -1;
	}
	
	/**
	 * Checks if this pair contains the given Individual.
	 * @param ind
	 * @return
	 */
	public boolean contains(Individual ind) {
		return ((one == ind) || (two == ind));
	}
	
	/**
	 * Check if an object is part of both this pair and the given one.
	 * @param other
	 * @return
	 */
	public boolean overlaps(CombinedPair other) {
		return (other.contains(one) || other.contains(two));
	}
}
