/*
 * Created on 30.aug.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package deb;

import java.util.TreeMap;
import java.util.Iterator;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;

import javax.xml.parsers.*;

/**
 * @author alver
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class InitialValues {

	protected double[] values = null;
	
	public InitialValues(double[] val) {
		values = val;
	}
	
	/**
	 * 
	 */
	public InitialValues(File f) throws IOException {
		super();
		parseValues(f);
	}

	public void parseValues(File f) throws IOException {
		TreeMap tm = new TreeMap();
		InitialValueHandler ph = new InitialValueHandler(tm);
		SAXParserFactory parserFactory = SAXParserFactory.newInstance();
		try {
			SAXParser parser = parserFactory.newSAXParser();
			parser.parse(f, ph);
		} catch (Exception ex) {
			ex.printStackTrace();
		}	
		//System.out.println("InitialValues: "+tm.size());
		values = new double[tm.size()];
		int pos = 0;
		for (Iterator i=tm.keySet().iterator(); i.hasNext();) {
			values[pos++] = ((Double)tm.get(i.next())).doubleValue();
		}
	}
	
	/**
	 * Stores these initial values in XML format parsable by this class.
	 * @param f The file to save to.
	 * @throws IOException For any IO exception occuring during the save.
	 */
	public void storeValues(File f) throws IOException {
		Writer fw = new OutputStreamWriter(new FileOutputStream(f), "UTF8");
		fw.write("<?xml version='1.0' encoding='UTF-8'?>\n<initialValues>\n");
		for (int i=0; i<values.length; i++) {
			fw.write("  <initialValue number=\""+(i+1)+"\" value=\""+values[i]+"\" />\n");
		}
		fw.write("</initialValues>\n");
		fw.close();
	}

	/**
	 * Returns a clone of the state array, to prevent the values from being modified externally.
	 * @return The initial states.
	 */
	public double[] getValues() {
		return (double[])values.clone();
	}
}
