/*
 * Created on 23.aug.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package deb;

/**
 * @author alver
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public interface Predator extends Individual {


	/**
	 * This method should calculate rate of feed intake of this predator - given as number of prey items per day.
	 * The result will be used to resolve predation and calculate the nutrients aquired from the prey.
	 * @param t The current time.
	 * @param population The population to which this individual belongs.
	 * @param environmentalParameters
	 * @return The number of prey items eaten.
	 */
	public double predation(double t, Population population, Parameters environmentalParameters);
	
	/**
	 * This method is a setter for this time step's {@param NutrientIntake} for the predator. The values are
	 * calculated after the predator has reported how much it will eat.
	 * @param ni The NutrientIntake.
	 */
	public void setNutrientIntake(NutrientIntake ni);
	
	/**
	 * Method for accessing the current time step's {@param NutrientIntake} for the predator.
	 * @return The current NutrientIntake.
	 */
	public NutrientIntake getNutrientIntake();
	
	public Predator spawnAndGetChild(double t);
        
        /**
         * Get the number of individuals this predator has eaten during its simulated lifetime.
         */
        public int unitsEaten();
}
