/*
 * ScheduleParameter.java
 *
 * Created on October 31, 2005, 7:45 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package deb;

/**
 *
 * @author alver
 */
public class ScheduleParameter extends Parameter {
    
    private double[][] schedule;
    
    /** Creates a new instance of ScheduleParameter */
    public ScheduleParameter(double[][] values) {
        this.schedule = values;
    }

    public double getLastScheduledValue(double t) {
        int piv = -1;
        for (int i=0; i<schedule.length; i++) {
            if (schedule[i][0] <= t)
                piv = i;

        }
        // Haven't reached scheduled time yet. Return -1.
        if (piv < 0)
            return -1;
        else return schedule[piv][1];
        
    }

    public double getTimeSinceScheduled(double t) {
        int piv = -1;
        for (int i=0; i<schedule.length; i++) {
            if (t >= schedule[i][0])
                piv = i;
            else
                break;
        }
        if (piv >= 0)
            return t-schedule[piv][0];
        else
            // Haven't reached scheduled time yet. Return -1.
            return -1;
    }
    
    
}
