/*
 * Created on 30.aug.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package deb;

/**
 * @author alver
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public interface SimulationMonitor {

	/**
	 * This method is called when the simulation starts.
	 * @param t The initial time.
	 * @param pop The simulated population.
	 */
	public void simulationStarted(double t, Population pop);
	
	/**
	 * This method is called by the simulator with regular intervals, set in the simulator itself.
	 * @param t The current time.
	 * @param pop The simulated population.
	 */
	public void simulationUpdate(double t, Population pop);

	/**
	 * This method is called by the simulator to indicate that the simulation result so far
	 * should be stored. Typically, this will require the monitor to perform the same functions
	 * as that performed by simulationFinished().
	 * @param t
	 * @param pop
	 */
	public void simulationInterval(double t, Population pop);
	
	/**
	 * This method is called when the simulation finishes.
	 * @param t The end time.
	 * @param pop The simulated population.
	 */
	public void simulationFinished(double t, Population pop);
        
        public SimulationMonitor copy(Parameters par, String directorySuffix);
}
