/*
 * Created on 20.des.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package deb;

import javax.swing.Timer;
import java.awt.event.*;

/**
 * This class implements a SimulationTrigger that ticks regularly (using javax.swing.Timer) with the given
 * delay per tick and time steps per tick. 
 * 
 * The trigger is started using the start() method. It will tick immediately, and subsequently at the given interval.
 * 
 * The trigger is stopped when the simulationFinished() method is called.
 */
public class StandardTrigger implements SimulationTrigger, ActionListener {

	private int delay, ticks;
	private boolean finished = false;
	private Simulator sim;
	Timer timer;
	
	/**
	 * 
	 */
	public StandardTrigger(Simulator sim, int delay, int ticks) {
		super();
		this.delay = delay;
		this.ticks = ticks;
		this.sim = sim;
		
	}

	public void start() {
		Timer timer = new Timer(delay, this);
		sim.trig(this, ticks);
		timer.start();
	}
	
	public void actionPerformed(ActionEvent e) {
		sim.trig(this, ticks);
		if (finished)
			timer.stop();
	}
	
	/* (non-Javadoc)
	 * @see deb.SimulationTrigger#ticksCompleted()
	 */
	public void ticksCompleted() {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see deb.SimulationTrigger#simulationFinished()
	 */
	public void simulationFinished() {
		finished = true;		
	}

}
