package deb.control;

import deb.Population;
import deb.Parameters;
import deb.Simulator;

/**
 * Created by IntelliJ IDEA.
 * User: alver
 * Date: Nov 8, 2006
 * Time: 10:01:28 AM
 * To change this template use File | Settings | File Templates.
 */
public interface PredictiveController {

    /**
     * The prediction interval is the time in simulation time units between each predictive run.
     * @return The prediction interval.
     */
    public double getPredictionInterval();

    /**
     * Launch a predictive run. This method should operate on copies of the Population argument only,
     * not advancing the state of the base population.
     * @param pop The population in the current initial state.
     * @param envPar The environmental parameters of the simulation.
     */
    public void makePredictiveRun(double t, Simulator sim, Population pop, Parameters envPar);

}
