/*
 * Created on 13.sep.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package deb.fishtank;

import deb.BaseFeedDynamic;
import deb.Parameters;
import deb.StepSolver;

/**
 * @author alver
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class AlgaDynamic implements BaseFeedDynamic {

	private double concentration;
        private double growthRate = 0;
	double totalPredation = 0;
        
	Parameters par;	
	
	/**
	 * 
	 */
	public AlgaDynamic(Parameters par) {
		super();
		this.par = par;
	}

        public BaseFeedDynamic copy(Parameters par) {
            AlgaDynamic newDyn = new AlgaDynamic(par);
            newDyn.concentration = this.concentration;
            newDyn.totalPredation = this.totalPredation;
            newDyn.growthRate = this.growthRate;
            return newDyn;
        }

        
	public void resetToSetPoint(double t) {
		
		setLevel(par.get("baseFeedReference", t));
	}
	
	public void addBySetPoint(double t) {
		setLevel(par.get("baseFeedReference", t) + concentration);
		//System.out.println(""+concentration);
	}
	
	/* (non-Javadoc)
	 * @see deb.BaseFeedDynamic#getConcentration()
	 */
	public double getLevel() {
		return Math.max(0, concentration);
	}

        
	public void setLevel(double level) {
		this.concentration = level;//Math.max(0, level);
                //if (concentration < 0)
                //    System.out.println("..");
                /*if (Double.isNaN(this.concentration)) {
                    this.concentration = 0;
                }*/
	}

        public void increaseLevel(double increase) {
            setLevel(this.concentration + increase);

        }
        
	public void dilute(double dilutionRate) {
            if (concentration > 0)
		setLevel(getLevel()*(1-dilutionRate));
	}
	
	public double energyDensity(double t, Parameters par) {
		return par.get("P_X", t)*par.get("prot_energy", t)
			+ (par.get("L_X", t)+par.get("DHA_X", t))*par.get("lip_energy", t);
	}
	
	public double f(double t, double level, double removal, Parameters envPar) {
            double res = (concentration>0 ? concentration : 0)*growthRate - removal*par.get("WW_DW_X", t)/par.get("V_w", t);// - concentration*envPar.get("Q_w_alga", t);
            return res;
	}
	
	/* (non-Javadoc)
	 * @see deb.BaseFeedDynamic#update(double, deb.Parameters)
	 */
	public void update(double t, double dt, double removal, Parameters envPar) {
            /*if (Double.isNaN(removal)) {
                    Thread.dumpStack();
                    System.out.println("jub");
                    
                }*/
            if (par.containsKey("baseFeedGrowthRate")) {
                double cc = par.get("baseFeedCarryingCapacity", t);
                growthRate = par.get("baseFeedGrowthRate", t)*(1-concentration*concentration/(cc*cc));
            }
		
            totalPredation += removal;
            setLevel(StepSolver.stepBaseFeedDynamic(this, t, dt, concentration, removal, envPar));

	}

}
