/*
 * Created on 28.jan.2005
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package deb.fishtank;

import deb.Predator;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

import deb.Functions;
import deb.Parameters;
import deb.Population;
import deb.SimulationMonitor;

/**
 * @author alver
 * 
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class LarvaMonitor implements SimulationMonitor {

	ArrayList lCount = new ArrayList();
	ArrayList lVal = new ArrayList();
	ArrayList lDeriv = new ArrayList();

	Parameters par;

	String directory;

	/**
	 *  
	 */
	public LarvaMonitor(Parameters par, String directory) {
		super();
		this.par = par;
		this.directory = directory;
	}

          public SimulationMonitor copy(Parameters par, String suffix) {
              LarvaMonitor newMon = new LarvaMonitor(par, directory+"/"+suffix);
              newMon.lCount = (ArrayList)lCount.clone();
              newMon.lVal = (ArrayList)lVal.clone();
              newMon.lDeriv = (ArrayList)lDeriv.clone();
              return newMon;
    }
        
	/*
	 * (non-Javadoc)
	 * 
	 * @see deb.SimulationMonitor#simulationStarted(double, deb.Population)
	 */
	public void simulationStarted(double t, Population pop) {
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see deb.SimulationMonitor#simulationUpdate(double, deb.Population)
	 */
	public void simulationUpdate(double t, Population pop) {
		record(t, pop);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see deb.SimulationMonitor#simulationInterval(double, deb.Population)
	 */
	public void simulationInterval(double t, Population pop) {
		simulationFinished(t, pop);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see deb.SimulationMonitor#simulationFinished(double, deb.Population)
	 */
	public void simulationFinished(double t, Population pop) {
		record(t, pop);
		
		try {
			Functions.saveToFile(lCount, new File(directory+"/larvaCount.dlm"));
			FileWriter fwL = new FileWriter(new File(directory + "/larva.dlm"));
			FileWriter fwDL = new FileWriter(new File(directory
					+ "/derivedLarva.dlm"));

			for (int i = 0; i < lVal.size(); i++) {
				double[] val = (double[]) lVal.get(i);
				double[] dVal = (double[]) lDeriv.get(i);
				if (val != null) {
					for (int j = 0; j < val.length; j++) {
						fwL.write(val[j] + (j < val.length - 1 ? "\t" : ""));
					}
					fwL.write("\n");

					for (int j = 0; j < dVal.length; j++) {
						fwDL.write(dVal[j] + (j < dVal.length - 1 ? "\t" : ""));
					}
					fwDL.write("\n");
				}
			}
			fwL.close();
			fwDL.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}

	private void record(double t, Population pop) {
		lVal.add(pop.getMeanPredatorStates());
		lDeriv.add(Functions.mean(pop.getPredatorDerivedOutputs(t)));
                
                double totalPred = 0;
                List predators = pop.getPredators();
                for (Iterator i=predators.iterator(); i.hasNext();) {
                    Predator pred = (Predator)i.next();
                    totalPred += pred.unitsEaten();
                }
		lCount.add(new double[] {Functions.countIndividuals(pop.getPredators()), totalPred}) ;
	}

  
}