/*
 * Created on 09.des.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package deb.fishtank;

import deb.Parameters;
import deb.Population;
import deb.operations.Operation;
import java.util.Iterator;

/**
 * @author alver
 *
 * Removes a given fraction (defined by the parameter "removeEggsFraction") of eggs from
 * a rotifer population.
 */
public class RemoveEggs implements Operation {

	Parameters par;
	
	public RemoveEggs(Parameters par) {
		this.par = par;
	}
	
	/* (non-Javadoc)
	 * @see deb.operations.Operation#performNow(double, double)
	 */
	public boolean performNow(double t, double dt) {
        double schedTime = par.getTimeSinceScheduled("removeEggsSchedule", t);
        if ((schedTime >= 0) && (schedTime < dt))
			return true;
		else
			return false;
	}

	/* (non-Javadoc)
	 * @see deb.operations.Operation#performOperation(double, double, deb.Population, deb.Parameters)
	 */
	public void performOperation(double t, double dt, Population pop,
			Parameters envPar) {
		double fraction = par.getLastScheduledValue("removeEggsSchedule", t);
        //System.out.println("Remove eggs: "+fraction);
        for (Iterator i=pop.getHerbivores().iterator(); i.hasNext();) {
			Object ind = i.next();
			if (ind instanceof Rotifer) {
				Rotifer rot = (Rotifer)ind;
				// Cycle through all eggs:
				for (Iterator j = rot.getEggs().iterator(); j.hasNext();) {
                    j.next();
                    //RotiferModel.RotiferEgg egg = (RotiferModel.RotiferEgg)j.next();
					// Roll a random number, and possibly remove the egg:
                    double rnd = Math.random();
                    //System.out.println("Rnd: "+rnd);
                    if (rnd < fraction)
						j.remove();
				}
			}
		}

	}

        public Operation copy(Parameters par) throws UnsupportedOperationException {
            return new RemoveEggs(par);
        }
}
