/*
 * Rotifer.java
 *
 * Created on October 4, 2005, 11:04 AM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package deb.fishtank;

import deb.Herbivore;
import deb.InitialValues;
import deb.NutrientIntake;
import java.util.List;

/**
 * This interface refines the Herbivore interface to include properties common to all rotifer models. This
 * facilitates easy switching between different rotifer model classes.
 *
 * @author alver
 */
public interface Rotifer extends Herbivore {
    
   public void addNutritionalContent(NutrientIntake ni, double multiplier, double t);
   
   public int getEggCount();
   
   public void setT0(double t0);
   
   public double getT0();
   
    public void setAmicticFemale(boolean amictic);
    
   public boolean isAmicticFemale();
   
   public boolean isFertilized();
   
   /**
    * This method returns whether a male would be attracted to this female.
    */
   public boolean eligibleForMating();
   
   /**
    * If the female is mictic, not too old for fertilization, and not already fertilized,
    * set its fertilization status to true.
    */
   public boolean fertilizeIfPossible(RotiferPopulation pop);
   
   /**
    * Rotifers may attach to walls or other structures instead of swimming in the water
    * column. This can have a noticeable effect on the dynamics of rotifer density in a
    * larval first feeding tanks, since free-swimming rotifers can be carried out with the
    * water exchange.
    */
   public boolean isAttached();
   
   public InitialValues getChildInitialValue();
   
   public List getEggs();
}
