/*
 * Created on 12.okt.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package deb.fishtank.gui;

import deb.Population;
import deb.SimulationMonitor;
import deb.SimulationTrigger;
import deb.Simulator;

import javax.swing.*;

import java.awt.BorderLayout;
import java.awt.event.*;


/**
 * @author alver
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class ControlPanel extends JFrame implements SimulationMonitor, SimulationTrigger {

		JTextField textField = new JTextField();
		JButton stop = new JButton("Stop"), storeInterval = new JButton("Store"),
			tick = new JButton("Tick");
		JToggleButton pause = new JToggleButton("Pause");
		JProgressBar bar;
		JLabel indCount, timer, average;
		final String LABEL = "Individuals: ",
			TIME = "Time: ",
			AVG= "Avg. n: ";
		Simulator simu;
		private ControlPanel ths = this;
		
		public ControlPanel(Simulator sim) {
			simu = sim;
			sim.addSimulationMonitor(this);
			//sim.setExternalTriggingEnabled(true); /// XXX: setter ekstern trigging her!!!
			bar = new JProgressBar((int)sim.getT_0(), (int)sim.getT_end());
			indCount = new JLabel(LABEL+" - ");
			average = new JLabel(AVG+" - ");
			timer = new JLabel(TIME+sim.getT_0());
			stop.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int answer = JOptionPane.showConfirmDialog(null, "Stop?", "Stop", JOptionPane.YES_NO_OPTION);
					if (answer == JOptionPane.OK_OPTION) {
						simu.stopSimulation(true);
						stop.setEnabled(false);
					}
				}
			});

			storeInterval.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					simu.reportSimulationInterval();
				}
			});
			
			addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					simu.stopSimulation(false);
					System.exit(0);
				}
			});
			
			pause.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					simu.setPaused(!simu.isPaused());
				}
			});
			
			tick.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					simu.trig(ths, 20);
				}
			});
			
			JPanel pan = new JPanel();
			pan.setLayout(new BoxLayout(pan, BoxLayout.Y_AXIS));
			getContentPane().setLayout(new BorderLayout());
			pan.add(textField);
			pan.add(timer);
			pan.add(indCount);
			pan.add(average);			
			getContentPane().add(pan, BorderLayout.NORTH);
			pan = new JPanel();
			pan.setLayout(new BoxLayout(pan, BoxLayout.X_AXIS));
			pan.add(pause);
			pan.add(storeInterval);
			//pan.add(tick);
			pan.add(stop);
			getContentPane().add(pan, BorderLayout.CENTER);
			getContentPane().add(bar, BorderLayout.SOUTH);
			pack();
		}


		/* (non-Javadoc)
		 * @see deb.SimulationMonitor#simulationStarted(double, deb.Population)
		 */
		public void simulationStarted(double t, Population pop) {
		}


		/* (non-Javadoc)
		 * @see deb.SimulationMonitor#simulationUpdate(double, deb.Population)
		 */
		public void simulationUpdate(double t, Population pop) {
			final double time = t;
			final Population popu = pop;
			SwingUtilities.invokeLater(new Thread() {
				public void run() {
					String s = ""+time;
					if (s.length() > 6)
						s = s.substring(0, 6);
					timer.setText(TIME+s);
					bar.setValue((int)time);
					int percent = (int)(100.0*bar.getPercentComplete());
					setTitle(percent+" %");
					indCount.setText(LABEL+popu.getHerbivoreObjectCount());
					if (popu.getHerbivoreObjectCount() > 0)
						average.setText(AVG+(((int)popu.getHerbivoreCount())/(popu.getHerbivoreObjectCount())));
					else
						average.setText(AVG+"-");
				}
			});
		}

		public void simulationInterval(double t, Population pop) {
		}
		
		
		/* (non-Javadoc)
		 * @see deb.SimulationMonitor#simulationFinished(double, deb.Population)
		 */
		public void simulationFinished(double t, Population pop) {
			final int time = (int)Math.ceil(t);
			SwingUtilities.invokeLater(new Thread() {
				public void run() {
					bar.setValue(time);
					pause.setEnabled(false);
					stop.setEnabled(false);
					storeInterval.setEnabled(false);
					setTitle("Done");
				}
			});
		}


		/* (non-Javadoc)
		 * @see deb.SimulationTrigger#ticksCompleted()
		 */
		public void ticksCompleted() {
			System.out.println("Ticks completed");
			
		}


		/* (non-Javadoc)
		 * @see deb.SimulationTrigger#simulationFinished()
		 */
		public void simulationFinished() {
			// TODO Auto-generated method stub
			
		}

    public SimulationMonitor copy(deb.Parameters par, String directory) {
        return null;
    }
		
                
		
}
