/*
 * PlotControlPanel.java
 *
 * Created on 30. juni 2005, 16:38
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package deb.fishtank.gui;

import deb.OpenEndedDataset;
import deb.gui.RealTimePanel;
import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.util.Map;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author alver
 */
public class PlotControlPanel extends JPanel {
    
    Map<String,OpenEndedDataset> datasets;
    GridBagLayout gbl = new GridBagLayout();
    GridBagConstraints con = new GridBagConstraints();
    JDialog wind = new JDialog((JFrame)null, "Plots", false);
    
    /** Creates a new instance of PlotControlPanel */
    public PlotControlPanel(Map<String,OpenEndedDataset> datasets) {
        this.datasets = datasets;
        setupLayout();
        
        wind.getContentPane().setLayout(new BorderLayout());
        wind.getContentPane().add(this, BorderLayout.CENTER);
        wind.pack();

    }
    
    protected final void setupLayout() {
        setLayout(gbl);
        con.anchor = GridBagConstraints.WEST;
        con.fill = GridBagConstraints.BOTH;
        
        for (String key: datasets.keySet())
            addDataset(key, datasets.get(key));
    }
    
    protected void addDataset(final String name, final OpenEndedDataset dataset) {
        //System.out.println(name);
        
        con.weightx = 1;
        con.gridwidth = 1;
        JLabel lab = new JLabel(name);
        gbl.setConstraints(lab, con);
        add(lab);
        con.weightx = 0;
        final JCheckBox cb = new JCheckBox("Track", true);
        cb.setEnabled(false);
        cb.setHorizontalTextPosition(cb.RIGHT);
        gbl.setConstraints(cb, con);
        add(cb);
        final JButton but = new JButton("Show");
        con.gridwidth = con.REMAINDER;
        gbl.setConstraints(but, con);
        add(but);
        
        cb.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent e) {
                dataset.setOnline(cb.isSelected());
            }
        });
        
        but.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                RealTimePanel panel = new RealTimePanel(dataset, name, dataset.getXLabel(), 
                            dataset.getYLabel());
                JDialog diag = panel.createSimpleWindow(wind, name);
                diag.addWindowListener(new WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        but.setEnabled(true);
                        cb.setEnabled(false);
                    }
                    
                });
                diag.setVisible(true);
                but.setEnabled(false);
                cb.setEnabled(true);
            }
        });
    }
    
    public JDialog createSimpleWindow(JFrame parent) {
        return wind;
    }
    
}
