package deb.gui;

import java.text.DecimalFormat;
import javax.swing.*;
import java.awt.*;
import org.jfree.chart.*;
import org.jfree.chart.plot.*;
import org.jfree.chart.axis.*;
import org.jfree.chart.renderer.xy.*;
import deb.*;
import org.jfree.data.xy.XYDataset;

public class RealTimePanel extends JPanel{
    
    JProgressBar bar;
    
    final int DEPTH_STATE = 2;
    
    OpenEndedDataset dataset;
    ChartPanel chartP;
    JToolBar tlb = new JToolBar();
    JLabel
            time = new JLabel("-", JLabel.RIGHT),
            depth = new JLabel("0.0", JLabel.RIGHT);
    DecimalFormat timeForm = new DecimalFormat("###0.00");
    JSlider simSpeed = new JSlider(JSlider.HORIZONTAL, 0, 100, 20),
            depthInp = new JSlider(JSlider.HORIZONTAL, 0, 200, 0);
    private boolean dynamicXAxisSet = false;
    
    public RealTimePanel(OpenEndedDataset dataset, String title, String xLabel, String yLabel) {
        this.dataset = dataset;
        setupLayout(title, xLabel, yLabel);
    }
    
    private void setupLayout(String title, String xLabel, String yLabel) {
        setLayout(new BorderLayout());
        
        chartP = createChart(dataset, title, xLabel, yLabel);
        /*XYPlot plot = chartP.getChart().getXYPlot();
        NumberAxis axis = (NumberAxis)plot.getDomainAxis();
        //NumberAxis axis2 = new NumberAxis(Globals.lang("Depth"));
        //plot.setRangeAxis(1, axis2);
        plot.mapDatasetToRangeAxis(1, 1);
        StandardXYItemRenderer renderer2 = new StandardXYItemRenderer();
        renderer2.setPaint(java.awt.Color.blue);
        plot.setRenderer(1, renderer2);
        //axis2.setInverted(true);
        //axis2.setLabelPaint(java.awt.Color.blue);
        //axis2.setTickMarkPaint(java.awt.Color.blue);
        //axis2.setTickLabelPaint(java.awt.Color.blue);
        axis.setAutoRange(false);
        axis.setRange(0, dataset.getEndTime());*/
        add(chartP, BorderLayout.CENTER);
        
    }
    
    
    public ChartPanel createChart(OpenEndedDataset dataset, String title, String xLabel, 
            String yLabel) {
        // Create the chart:
        JFreeChart fc = ChartFactory.createXYLineChart
                (title, xLabel, yLabel, dataset,
                PlotOrientation.VERTICAL, true, true, false);
        XYPlot plot = fc.getXYPlot();
        NumberAxis axis = (NumberAxis)plot.getRangeAxis();
        axis.setAutoRangeIncludesZero(false);
        fc.setAntiAlias(false);
        fc.setLegend(null);
        ChartPanel cp = new ChartPanel(fc);
        return cp;
    }
    
    
    public JDialog createSimpleWindow(JDialog parent, String title) {
        JDialog diag = new JDialog(parent, title, false);
        diag.getContentPane().setLayout(new BorderLayout());
        diag.getContentPane().add(this, BorderLayout.CENTER);
        diag.pack();
        return diag;
    }
    
    
}
