/*
 * Created on 13.des.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package deb.operations;

import deb.BaseFeedDynamic;
import deb.MissingParameterException;
import deb.Parameters;
import deb.Population;

/**
 * @author alver
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class AddBaseFeedChemostat implements Operation {

	private double dil_t0 = 0;
	
	private Parameters par;
	
	/**
	 * @param bfd
	 */
	public AddBaseFeedChemostat(Parameters par) {
		this.par = par;
		
		dil_t0 = par.get("dilutionT0", 0);
	}
	
	/* (non-Javadoc)
	 * @see deb.operations.Operation#performNow(double, double)
	 */
	public boolean performNow(double t, double dt) {
		return t >= dil_t0;
	}

	/* (non-Javadoc)
	 * @see deb.operations.Operation#performOperation(double, double, deb.Population, deb.Parameters)
	 */
	public void performOperation(double t, double dt, Population pop,
			Parameters envPar) {
		BaseFeedDynamic baseFeedDynamic = pop.getBaseFeedDynamic();
		boolean continuousDilution = par.getBool("continuousDilution", t);
		double inDensity = par.get("chemostatInflowDensity", t),
			dilutionRate = par.get("dilutionRate", t);

		baseFeedDynamic.setLevel(baseFeedDynamic.getLevel() + dt*inDensity*dilutionRate);


	}
        
    public Operation copy(Parameters par) throws UnsupportedOperationException {
        return new AddBaseFeedChemostat(par);
    }

}
