/*
 * Created on 13.des.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package deb.operations;

import deb.BaseFeedDynamic;
import deb.MissingParameterException;
import deb.Parameters;
import deb.Population;

/**
 * @author alver
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class AddBaseFeedContinuously implements Operation {

	
	private Parameters par;
	double[] additionTimes;
	double amountToAdd = 0, totalAdded = 0;
	private double bf_t0;
	boolean addToSetPoint;
	
	/**
	 * @param bfd
	 */
	public AddBaseFeedContinuously(Parameters par) {
		this.par = par;
		
		bf_t0 = par.get("baseFeedAdditionT0", 0);
		additionTimes = par.getArray("baseFeedAdditionTimes", 0);
		
	}
	
	/* (non-Javadoc)
	 * @see deb.operations.Operation#performNow(double, double)
	 */
	public boolean performNow(double t, double dt) {
		if (par.getBool("baseFeedAdditionOn", t) && (t > bf_t0)) {
                    return true;
		}
                else return false;
	}

	/* (non-Javadoc)
	 * @see deb.operations.Operation#performOperation(double, double, deb.Population, deb.Parameters)
	 */
	public void performOperation(double t, double dt, Population pop,
			Parameters envPar) {
            BaseFeedDynamic baseFeedDynamic = pop.getBaseFeedDynamic();
            boolean continuousDilution = par.getBool("continuousDilution", t);
            double inDensity = par.get("baseFeedReference", t);
            baseFeedDynamic.setLevel(baseFeedDynamic.getLevel() + dt*inDensity);

	}
        
    public Operation copy(Parameters par) throws UnsupportedOperationException {
        return new AddBaseFeedContinuously(par);
    }

}
