/*
 * AddBaseFeedTabled.java
 *
 * Created on October 28, 2005, 3:26 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package deb.operations;

import deb.BaseFeedDynamic;
import deb.Parameters;

/**
 *
 * @author alver
 */
public class AddBaseFeedTabled implements Operation {
    
    public static final String SCHEDULE = "baseFeedAdditionTable";
    private Parameters par;
    private double amountToAdd = 0;
    
    /** Creates a new instance of AddBaseFeedTabled */
    public AddBaseFeedTabled(Parameters par) {
        this.par = par;
        
    }

    public void performOperation(double t, double dt, deb.Population pop, deb.Parameters envPar) {
        pop.getBaseFeedDynamic().setLevel(pop.getBaseFeedDynamic().getLevel()+amountToAdd);
    }

    public boolean performNow(double t, double dt) {
        double value = par.getTimeSinceScheduled(SCHEDULE, t);		
        boolean res = (value >= 0) && (value < dt);
        if (res) {

            amountToAdd = par.getLastScheduledValue(SCHEDULE, t);
            //System.out.println("add t="+t+"\tvalue="+amountToAdd);
        }
        return res;
    }
     
    public Operation copy(Parameters par) throws UnsupportedOperationException {
        return new AddBaseFeedTabled(par);
    }

}
