/*
 * Created on 07.apr.2005
 *
 * Removes all base feed at the given times.
 */
package deb.operations;

import deb.BaseFeedDynamic;
import deb.Parameters;
import deb.Population;

/**
 * @author alver
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class ClearBaseFeed implements Operation {

	double[] times;
	int piv=0; // Pointer to the next operation to run.
	
        /**
	 * 
	 */
	public ClearBaseFeed(Parameters par) {
		super();
		times = par.getArray("clearBaseFeedTimes", 0);
		
	}

	/* (non-Javadoc)
	 * @see deb.operations.Operation#performNow(double, double)
	 */
	public boolean performNow(double t, double dt) {
		if (piv == times.length)
			return false;
		double diff = t-times[piv];
		if ((diff >= 0) && (diff < dt)) {
			return true;
		}
		else
			return false;
	}

	/* (non-Javadoc)
	 * @see deb.operations.Operation#performOperation(double, double, deb.Population, deb.Parameters)
	 */
	public void performOperation(double t, double dt, Population pop,
			Parameters envPar) {
		
		pop.getBaseFeedDynamic().setLevel(0);
		piv++;
	}

        public Operation copy(Parameters par) throws UnsupportedOperationException {
            return new ClearBaseFeed(par);
        }

}
