package deb.paramtools;

import java.io.File;
import java.io.IOException;

/**
 * Interface for classes performing modifications to a parameter xml file.
 */
public interface ParamFileModifier {

    /**
     * Do the file modification.
     * @param file The file to work on
     * @return true if the operation was successful, false otherwise.
     * @throws IOException If something goes wrong.
     */
    public boolean modifyFile(File file) throws IOException;


}
